#include "event.h"
#include <stdlib.h>
#include <string.h>

struct event *event_list = NULL;

struct event *event_create(const char *name, int (*action) (void *args)) {
	struct event *ev = NULL;
	ev = (struct event *)malloc(sizeof(struct event));

	if (ev) {
		ev->event_name = strdup(name);
		ev->action = action;
		ev->next = NULL;
	}

	return ev;
}

int event_register(const char *name, int (*action) (void *args)) {
	struct event *ev;
	ev = event_create(name, action);
	if (ev) {
		ev->next = event_list;
		event_list = ev;
	}
}

int event_fire(const char *name, void *args) {
	struct event *ev;
	int result = 0;
	ev = event_list;

	while (ev) {
		if (strcmp(name, ev->event_name) == 0) {
			/* found the event, fire its action */
			result = (ev->action)(args);

			/* we don't break. this way, we can register more actions to one event */
		}

		ev = ev->next;
	}

	return result;
}

